import java.io.FileInputStream;
import java.io.IOException;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import de.kippdata.jaxb.example.*;

public class Main {

    /**
      * Dump the result
      */
    private static void out(ItemType item, String name) {
        System.out.println("\nResult:");
        System.out.println("  booleanPart=" + item.isBooleanPart());
        System.out.println("  shortPart=" + item.getShortPart());
        System.out.println("  intPart=" + item.getIntPart());
        System.out.println("  longPart=" + item.getLongPart());
        System.out.println("  floatPart=" + item.getFloatPart());
        System.out.println("  doublePart=" + item.getDoublePart());
        System.out.println("  bytePart=" + item.getBytePart());
    }

    public static void main(String[] args) {
        try {
            JAXBContext jc;
            Unmarshaller u;
            JAXBElement<?> itemElement;
            ItemType item;
            String file;
            String name = args[0];

            System.out.println("\nRunning test for '" + name + "'");
            file = name + "1.xml";
            System.out.println("\nUnmarshal '" + file + "' using a new JAXBContext");
            jc = JAXBContext.newInstance("de.kippdata.jaxb.example");
            u = jc.createUnmarshaller();
            itemElement = (JAXBElement<?>)u.unmarshal(new FileInputStream(file));
            item = (ItemType)itemElement.getValue();
            out(item, name);

            file = name + "2.xml";
            System.out.println("\nUnmarshal '" + file + "' reusing the JAXBContext");
            u = jc.createUnmarshaller();
            itemElement = (JAXBElement<?>)u.unmarshal(new FileInputStream(file));
            item = (ItemType)itemElement.getValue();
            out(item, name);

            file = name + "3.xml";
            System.out.println("\nUnmarshal '" + file + "' using again a new JAXBContext");
            jc = JAXBContext.newInstance("de.kippdata.jaxb.example");
            u = jc.createUnmarshaller();
            itemElement = (JAXBElement<?>)u.unmarshal(new FileInputStream(file));
            item = (ItemType)itemElement.getValue();
            out(item, name);

        } catch(JAXBException je) {
            je.printStackTrace();
        } catch(IOException ioe) {
            ioe.printStackTrace();
        }
    }
}
